﻿# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para filmenoi (por bogdanioanliviu)
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "filmenoi"
__category__ = "F,S"
__type__ = "generic"
__title__ = "Filme-noi.com"
__language__ = "ES"
__creationdate__ = "20131223"

DEBUG = config.get_setting("debug")

def isGeneric():
    return True

def mainlist(item):
    logger.info("[filmenoi.py] mainlist")
    #item.url="http://cinemaxx.rs/newvideos.html";
    item.url="http://www.filme-net.com/";
    return novedades(item)

def novedades(item):
    logger.info("[filmenoi.py] novedades")
    itemlist = []
	
    # Descarga la página
    data = scrapertools.cachePage(item.url)
	
    	
	#esta es para web situl Cinemaxx.rs
    #patron  = '<ul class="pm-ul-browse-videos thumbnails" id="pm-grid">[^<]+'
    #patron = '<li>[^<]+'
    #patron += '<div class="pm-li-video">[^<]+'
    #patron += '.*?<a href="([^"]+)".*?[^<]+<img src="([^"]+)" alt="([^"]+)".*?</li>'
	
	#esta es para web Filme-noi.com
    '''
    <div class="home_posts">
    <div class="home_post_shadow"></div>
    <div class="home_posts_thumbnail">
    <a href="http://www.filme-net.com/2014/01/reasonable-doubt-film-gratis-subtitrat-filme-online-2014.html" title="Reasonable Doubt film gratis subtitrat &#8211; (filme online 2014)">
    <img src="http://www.filme-net.com/wp-content/themes/Moviex versiune noua/timthumb.php?src=http://www.filme-net.com/wp-content/uploads/2014/01/Reasonable-Doubt-I-2014.jpg&amp;h=240&amp;w=170&amp;zc=1&amp;q=100" alt="Reasonable Doubt film gratis subtitrat &#8211; (filme online 2014)" title="Reasonable Doubt film gratis subtitrat &#8211; (filme online 2014)"/>
    </a>
    </div>
    <div class="home_posts_box">
    <div class="home_posts_rating">
    </div>
    <div class="home_posts_title">
    <h1><a href="http://www.filme-net.com/2014/01/reasonable-doubt-film-gratis-subtitrat-filme-online-2014.html" title="Reasonable Doubt film gratis subtitrat &#8211; (filme online 2014)"> Reasonable Doubt film gratis subtitrat &#8211; (filme online 2014)</a></h1>
    </div>
    <div class="home_posts_text">
    <p>Reasonable Doubt online subtitrat, (filme online 2014) gratis fara intrerupere 91 min &#8211; Crima | Thriller
    <p>O premisă interesantă , doi actori pe deplin capabile de Samuel L. Jackson , și Dominic Cooper , și este canadian , reteta de succes , am dreptate ? Adevărul este , intriga este ca standard și nerealist ca acesta devine , Jackson nu este el însuși , și ca un canadian , nu<br/><a href="http://www.filme-net.com/2014/01/reasonable-doubt-film-gratis-subtitrat-filme-online-2014.html" class="read-more">Read more &raquo;</a></p>
    </div>
    </div>
    </div>
    '''
    patron = '<div class="home_posts_thumbnail">[^<]+'
    patron += '<a href="([^"]+)"[^<]+<img src="([^"]+)" alt="([^"]+)"'
	
    matches = re.compile(patron,re.DOTALL).findall(data)
    if DEBUG: scrapertools.printMatches(matches)
	
    for scrapedurl,scrapedthumbnail,scrapedtitle in matches:
        thumbnail = scrapertools.find_single_match(scrapedthumbnail,"(http\://www.filme-net.com/wp-content/uploads/.*?.jpg)")
        scrapedplot = ""
        #if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]") 
        if (DEBUG): logger.info("url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"], title=["+scrapedtitle+"]") # Falla en sacar las imagenes por que tienen espacios
        itemlist.append( Item(channel=__channel__, action="findvideos", title=scrapedtitle , url=scrapedurl , thumbnail=thumbnail , plot=scrapedplot , folder=True) )
    
    
    #<a href='http://www.filme-net.com/page/2'>&rsaquo;</a>
    patron  = "<a href='([^']+)'>\&rsaquo\;</a>"
    matches = re.compile(patron,re.DOTALL).findall(data)
    if DEBUG: scrapertools.printMatches(matches)
    
    for match in matches:
        scrapedtitle = ">> Página siguiente"
        scrapedplot = ""
        scrapedurl = urlparse.urljoin(item.url,match)
        scrapedthumbnail = ""
        if (DEBUG): logger.info("url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"], title=["+scrapedtitle+"]")
        itemlist.append( Item(channel=__channel__, action="novedades", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=True) )

    return itemlist

def play(item):
    logger.info("[filmenoi.py] play")
    itemlist=[]

    if item.server=="linkbucks":
        logger.info("Es linkbucks")
        
        # Averigua el enlace
        from servers import linkbucks
        location = linkbucks.get_long_url(item.url)
        logger.info("location="+location)
        
        # Extrae la URL de saltar el anuncio en adf.ly
        if location.startswith("http://adf"):
            # Averigua el enlace
            from servers import adfly
            location = adfly.get_long_url(location)
            logger.info("location="+location)

        from servers import servertools
        itemlist=servertools.find_video_items(data=location)
        for videoitem in itemlist:
            videoitem.channel=__channel__
            videoitem.folder=False

    else:
        itemlist.append(item)

    return itemlist
 
# Verificación automática de canales: Esta función debe devolver "True" si está ok el canal.
def test():
    # mainlist
    novedades_items = mainlist(Item())
    # Da por bueno el canal si alguno de los vídeos de "Novedades" devuelve mirrors
    bien = False
    for singleitem in novedades_items:
        mirrors_items = findvideos( item=singleitem )
        for mirror_item in mirrors_items:
            video_items = play(mirror_item)
            if len(video_items)>0:
                return True

    return False
